#include <vcl.h>
#pragma hdrstop

#include "autorun_main.h"
//---------------------------------------------------------------------------
#include "registry.hpp"
#pragma package(smart_init)
#pragma link "ElBtnEdit"
#pragma link "ElEdits"
#pragma link "ElNameEdits"
#pragma link "ElXPThemedControl"
#pragma link "ElTree"
#pragma link "ElTreeGrids"
#pragma resource "*.dfm"
TfrmMain *frmMain;
void WriteInAutoRun(int root, AnsiString Node, AnsiString RecName, AnsiString fName);
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void WriteInAutoRun(int root, AnsiString Node, AnsiString RecName, AnsiString fName)
{
TRegistry *reg = new TRegistry();
try
    {
    if (root == 0)
        {
        reg->RootKey = HKEY_CURRENT_USER;
        reg->OpenKey(Node, true);
        reg->WriteString(RecName, fName);
        reg->CloseKey();
        }
    if (root == 1)
        {
        reg->RootKey = HKEY_LOCAL_MACHINE;
        reg->OpenKey(Node, true);
        reg->WriteString(RecName, fName);
        reg->CloseKey();
        }
    }
__finally
    {
    delete reg;
    }
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnAddToAutoRunClick(TObject *Sender)
{
if ((edtFileName->Text.IsEmpty() == true) || (edtFileName->Text.IsEmpty() == true))
    {
    ShowMessage("Type name or select file for add to StartUp");
    edtFileName->SetFocus();
    return;
    }
int root;
AnsiString node, file;
if (rbRun->Checked == true)
    {
    node = "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run\\";
    }
if (rbRunOnce->Checked == true)
    {
    node = "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\RunOnce\\";
    }
if (rbHKCU->Checked == true)
    {
    root = 0;
    }
if (rbHKLM->Checked == true)
    {
    root = 1;
    }
WriteInAutoRun(root, node, edtName->Text, edtFileName->Text);

edtFileName->Text   =   "";
edtName->Text       =   "";

FormCreate(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
sgAutoRun->Items->Clear();

TStringList *names = new TStringList();
TRegistry *reg = new TRegistry();
reg->RootKey = HKEY_CURRENT_USER;
reg->OpenKeyReadOnly("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run\\");
reg->GetValueNames(names);
AnsiString keyname, value;

int k = 0;
for (int i = 0; i < names->Count; i ++)
    {
    keyname = names->Strings[i];
    value = reg->ReadString(keyname);
    sgAutoRun->Cells[0][k] = keyname;
    sgAutoRun->Cells[1][k] = "HKCU";
    sgAutoRun->Cells[2][k] = value;
    k ++;
    }
reg->CloseKey();

reg->RootKey = HKEY_LOCAL_MACHINE;
reg->OpenKeyReadOnly("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run\\");
reg->GetValueNames(names);
for (int j = 0; j < names->Count; j ++)
    {
    keyname = names->Strings[j];
    value = reg->ReadString(keyname);
    sgAutoRun->Cells[0][k] = keyname;
    sgAutoRun->Cells[1][k] = "HKLM";
    sgAutoRun->Cells[2][k] = value;
    k ++;
    }
reg->CloseKey();

delete reg;
delete names;
}
//---------------------------------------------------------------------------
void DellRec(int root, AnsiString keyname)
{
TRegistry *reg = new TRegistry();
if (root == 1)
    {
    reg->RootKey = HKEY_CURRENT_USER;
    reg->OpenKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run\\", true);
    reg->DeleteValue(keyname);
    reg->CloseKey();
    }
if (root == 2)
    {
    reg->RootKey = HKEY_LOCAL_MACHINE;
    reg->OpenKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run\\", true);
    reg->DeleteValue(keyname);
    reg->CloseKey();
    }
delete reg;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnRemoveClick(TObject *Sender)
{
int sel;

if (sgAutoRun->RowCount > 0)
    {
    sel = sgAutoRun->Selected->Index;
    }

AnsiString  root    =   sgAutoRun->Cells[1][sel],
            keyname =   sgAutoRun->Cells[0][sel];

if (root == "HKCU")
    {
    DellRec(1, keyname);
    }
if (root == "HKLM")
    {
    DellRec(2, keyname);
    }
FormCreate(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::edtNameKeyPress(TObject *Sender, char &Key)
{
if ((Key >= 'A') && (Key <= 'Z') || (Key >= 'a') && (Key <= 'z') ||
    (Key >= '0') && (Key <= '9') || (Key == VK_BACK))
    {
    return;
    }
Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::edtFileNameChange(TObject *Sender)
{
edtName->Text = ExtractFileName(edtFileName->Text);
}
//---------------------------------------------------------------------------

